/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package camadaDados;

import exceptions.PostoJahExiste;
import classesBasicas.*;
import exceptions.PostoInexistente;
import java.sql.SQLException;
import java.util.ArrayList;


/**
 *
 * @author dnr2
 */
public class RepositorioPosto {
    
    private Conexao cnn;
	
	public RepositorioPosto(Conexao cnn) {
		super();
		this.cnn = cnn;
	}

	public void cadastrarPosto(Posto f) throws PostoJahExiste {
            boolean bug = false;
            String query ="INSERT INTO SACIPosto " +
				"(CEP, NUMERO, RUA, BAIRRO ,CIDADE, ESTADO, PAIS, NOMEEMPRESA, REPUTACAO, LATITUDE, LONGITUDE  ) " +
				"VALUES " +
				"( " 
					+ f.getCep() + ", " 
					+ f.getNumero() + ", '"
					+ f.getRua() + "', '"
					+ f.getBairro() + "', '"
					+ f.getCidade() + "', '"
					+ f.getEstado() + "', '"
					+ f.getPais() + "', '"
                                        + f.getNome() + "', "
                                        + f.getReputacao() + ", '"
                                        + f.getLatitude() + "', '"
                                        + f.getLongitude() + "')";
            try {
                this.cnn.getStmt().execute(query);
            } catch (SQLException ex) {
                bug = true;
            }
            if(bug) throw new PostoJahExiste("Posto já cadastrado");
	}
	
        public Posto buscarPosto(int cep, int numero) throws SQLException, PostoInexistente{
            
            this.cnn.setRset ( 
			this.cnn.getStmt().executeQuery("SELECT CEP, NUMERO, RUA, BAIRRO ,CIDADE, ESTADO, PAIS, NOMEEMPRESA, REPUTACAO, LATITUDE, LONGITUDE " +
			" FROM SACIPosto WHERE CEP = " + cep + "AND NUMERO = " + numero)
		);
		
		Posto f = null; 
                                
		if(this.cnn.getRset().next()){
			 f = new Posto(
                               this.cnn.getRset().getInt("CEP"),
                               this.cnn.getRset().getInt("NUMERO"),
                               this.cnn.getRset().getString("NOMEEMPRESA"),
                               this.cnn.getRset().getInt("REPUTACAO"),
                               this.cnn.getRset().getString("RUA"),
                               this.cnn.getRset().getString("BAIRRO"),
                               this.cnn.getRset().getString("CIDADE"),
                               this.cnn.getRset().getString("ESTADO"),
                               this.cnn.getRset().getString("PAIS"),
                               this.cnn.getRset().getString("LATITUDE"),
                               this.cnn.getRset().getString("LONGITUDE")
			);
			
		} else {
			throw new PostoInexistente();
		}
		return f;
            
        }
        
        public void atualizarPosto(Posto f) throws PostoInexistente{
            boolean bug = false;
            
            String query ="UPDATE SACIPosto " +				
				" SET "  
					+ "CEP = '" + f.getCep() + "', " 
					+ "NUMERO = " + f.getNumero() + ", "
					+ "RUA = '" + f.getRua() + "', "
					+ "BAIRRO = '" + f.getBairro() + "', "
					+ "CIDADE = '" + f.getCidade() + "', "
					+ "ESTADO = '" + f.getEstado() + "', "
					+ "PAIS = '" + f.getPais() + "', "
                                        + "NOMEEMPRESA = '" + f.getNome() + "', "
                                        + "REPUTACAO = " + f.getReputacao() + ", "
                                        + "LATITUDE = '" + f.getLatitude() + "', "
                                        + "LONGITUDE = '" + f.getLongitude() + "'";
            try {
                this.cnn.getStmt().execute(query);
            } catch (SQLException ex) {
                bug = true;
            }
            if(bug) throw new PostoInexistente();
        }
        
        public ArrayList<Posto> buscarPostos() throws SQLException{
             this.cnn.setRset ( 
			this.cnn.getStmt().executeQuery("SELECT CEP, NUMERO, RUA, BAIRRO ,CIDADE, ESTADO, PAIS, NOMEEMPRESA, REPUTACAO, LATITUDE, LONGITUDE " +
			" FROM SACIPosto")
		);
		
		ArrayList<Posto> ret = new ArrayList<Posto>(); 
                                
		while(this.cnn.getRset().next()){
                     ret.add( new Posto(
                               this.cnn.getRset().getInt("CEP"),
                               this.cnn.getRset().getInt("NUMERO"),
                               this.cnn.getRset().getString("NOMEEMPRESA"),
                               this.cnn.getRset().getInt("REPUTACAO"),
                               this.cnn.getRset().getString("RUA"),
                               this.cnn.getRset().getString("BAIRRO"),
                               this.cnn.getRset().getString("CIDADE"),
                               this.cnn.getRset().getString("ESTADO"),
                               this.cnn.getRset().getString("PAIS"),
                               this.cnn.getRset().getString("LATITUDE"),
                               this.cnn.getRset().getString("LONGITUDE")
                               )
                           );			
		} 
		return ret;
        }
}
